/*************************************************************
Cross compilateur: CVAVR V2.04.08a
Project : PPE DMX512
Version : 1
Date    : 28/1/2011
Author  : Philippe Mariano                
Company : LYCEE Pierre Emile MARTIN       
Comments: Suivi de ligne 

Fichier : CHCOLO.c  
Description : Commande des LED RVB de
la carte de test

Chip type           : ATmega8535
Program type        : Application
Clock frequency     : 8,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 128
*************************************************************/
// =========================================================================================
#include <mega8535.h>

// -----------------------------------------------------------------------------------------
// Bibliothques non gnres par Wizard ( rajouter manuellement)
// -----------------------------------------------------------------------------------------     
#include <stdio.h>    // contient la fonction sprintf 
#include <delay.h>    // contient la fonction delay_ms
// -----------------------------------------------------------------------------------------
// Ces fichiers d'en-tte et les librairies correspondantes doivent tre placs
// dans les rpertoires du projet
// -----------------------------------------------------------------------------------------
#include "ssi2.h" 	// contient les fonctions Affiche_LCD, Lire_BP  
// -----------------------------------------------------------------------------------------
#define REGISTRE_PWM_R 	OCR1AL
#define REGISTRE_PWM_V  OCR1BL
#define REGISTRE_PWM_B  OCR0
// -----------------------------------------------------------------------------------------
// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x15
#endasm
#include <lcd.h>
// =========================================================================================


// =========================================================================================
void main(void)
{
// -----------------------------------------------------------------------------------------
// Declare your local variables here   
// -----------------------------------------------------------------------------------------
// type 		nom 					        description  
// -----------------------------------------------------------------------------------------
char display_buffer_ligne0[17]; 			        // tampon ligne 0 de l'afficheur
char display_buffer_ligne1[17]; 	       		    // tampon ligne 1 de l'afficheur
unsigned char Alpha_R=0,Alpha_R_1=0, Alpha_V=0;
unsigned char Alpha_V_1=0,Alpha_B_1=0,Alpha_B=0;	// Rapport cyclique
unsigned char BP;					                // Bouton-poussoir slectionn
// ----------------------------------------------------------------------------------------- 
// Coefficient pour le rglage du rapport cyclique du signal PWM
unsigned char Table_Alpha[11] = {0,26,51,77,102,128,153,179,204,230,255}; 
// -----------------------------------------------------------------------------------------
// Input/Output Ports initialization
// Port A initialization
// Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
// State0=P State1=P State2=P State3=P State4=P State5=P State6=T State7=T 
PORTA=0x3F;
DDRA=0x00;

// Port B initialization
// Func0=In Func1=In Func2=In Func3=Out Func4=In Func5=In Func6=In Func7=In 
// State0=T State1=T State2=T State3=0 State4=T State5=T State6=T State7=T 
PORTB=0x00;
DDRB=0x08;

// Port D initialization
// Func0=In Func1=In Func2=In Func3=In Func4=Out Func5=Out Func6=In Func7=In 
// State0=T State1=T State2=T State3=T State4=0 State5=0 State6=T State7=T 
PORTD=0x00;
DDRD=0x30;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 31,250 kHz
// Mode: Phase correct PWM top=FFh
// OC0 output: Non-Inverted PWM
TCCR0=0x64;
TCNT0=0x00;
OCR0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 31,250 kHz
// Mode: Ph. correct PWM top=00FFh
// OC1A output: Non-Inv.
// OC1B output: Non-Inv.
// Noise Canceler: Off
// Input Capture on Falling Edge
TCCR1A=0xA1;
TCCR1B=0x04;
TCNT1H=0x00;
TCNT1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// LCD module initialization
lcd_init(16);
// =========================================================================================
// Affichage du menu
// -----------------------------------------------------------------------------------------
sprintf(display_buffer_ligne0,"Rouge Vert Bleu");
sprintf(display_buffer_ligne1,"%-u%%  %-u%%  %-u%%",Alpha_R,Alpha_V,Alpha_B);
Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
// -----------------------------------------------------------------------------------------
while (1)
    { // dbut while
// -----------------------  Lire les consignes de rapport cyclique -------------------------
      BP = Lire_BP(); 
// -----------------------------------------------------------------------------------------
// ------------------------------------  Traiter -------------------------------------------      
    switch(BP)
          {
            case INC: if (Alpha_R < 90) Alpha_R = Alpha_R+10; else Alpha_R = 100; break;
            case DEC: if (Alpha_R > 10) Alpha_R = Alpha_R-10; else Alpha_R = 0; break;
            case OK: if (Alpha_V < 90) Alpha_V = Alpha_V+10; else Alpha_V = 100; break;
            case SET: if (Alpha_V > 10) Alpha_V = Alpha_V-10; else Alpha_V = 0; break;
            case ECHAP : if (Alpha_B < 90) Alpha_B = Alpha_B+10; else Alpha_B = 100; break;
            case ENTR : if (Alpha_B > 10) Alpha_B = Alpha_B-10; else Alpha_B = 0; break;
          }  
    REGISTRE_PWM_R = Table_Alpha[Alpha_R/10];
    REGISTRE_PWM_V = Table_Alpha[Alpha_V/10];
    REGISTRE_PWM_B = Table_Alpha[Alpha_B/10];      
// ----------------------------------------------------------------------------------------- 
// -------------------------------------  Ecrire -------------------------------------------         
    if ((Alpha_R != Alpha_R_1) || (Alpha_V != Alpha_V_1) || (Alpha_B != Alpha_B_1))
         {
            sprintf(display_buffer_ligne0,"Rouge Vert Bleu");
            sprintf(display_buffer_ligne1,"%-u%%  %-u%%  %-u%%",Alpha_R,Alpha_V,Alpha_B);
            Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
            Alpha_R_1 = Alpha_R; Alpha_V_1 = Alpha_V; Alpha_B_1 = Alpha_B;
         }

    };// fin while  
// -----------------------------------------------------------------------------------------
} // fin main
// =========================================================================================
